/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 2023 Roger Hale, Ben Moszkowski,
 * Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * sample of big integers
 */

/* run */ define test_1() = {
 exists X: {
     X=0z42  and X gets X ** 0z2 and len 7 and
     always format("X= %Z \n", X) }
}.

/* run */ define test_2() = {
  exists X,Y: {
     X=0z1  and Y=0z1 and Y gets Y + 0z1 and X gets 0z3 ** Y and len 29 and
     always format("X= %15Z Y = %3Z \n", X,Y) }
}.

/* run */ define test_3() = {
 exists X: {
     input X  and X gets X ** 0z2 and len 10 and
     always format("X= %Z \n", X) }
}.

/* run */ define test_4() = {
  exists X,Y: {
     X=0z1  and Y=1 and stable(Y) and
     X gets (X ** 0z2) + itompz(Y) and
     format("Y=%d itompz(Y)= %Z\n",Y,itompz(Y)) and
     len 10 and
     always format("X= %Z \n", X) }
}.

/* run */ define test_5() = {
  exists X,Y,Z: {
     X=0z4  and Y=1 and stable(Y) and
     X gets X + itompz(Y) and
     Z is mpztoi(X) and
     format("Y=%d itompz(Y)= %Z\n",Y,itompz(Y)) and
     len 10 and
     always format("X= %2Z mpztoi(X) = %2d\n", X, Z) }
}.

/* run */ define test_6() = {
 exists X : {
  list(X,5) and stable(struct X) and
  set zrandom_max = 0z5555 and
  set mp_random_seed = 0z55555 and
  forall i <|X| : { X[i] = zRandom and X[i] gets X[i] + X[i] and len(5)} and
   always output X
 }
}.
