/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 2023 Roger Hale, Ben Moszkowski,
 * Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * sample of hexadecimal
 */

/* run */ define test_1() = {
 exists X: {
     X=0x42  and X gets X ** 0x2 and len 7 and
     always format("X= %X \n", X) }
}.

/* run */ define test_2() = {
  exists X,Y: {
     X=0x1  and Y=0x0 and Y gets Y + 0x1 and X gets 0x3 ** Y and len 29 and
     always format("X= %15X Y = %3X \n", X,Y) }
}.

/* run */ define test_3() = {
 exists X: {
     input X  and X gets X ** 0x2 and len 10 and
     always format("X= %X \n", X) }
}.

/* run */ define test_4() = {
  exists X,Y: {
     X=0x1  and Y=1 and stable(Y) and
     X gets (X ** 0x2) + itompx(Y) and
     format("Y=%d itompx(Y)= %X\n",Y,itompx(Y)) and
     len 10 and
     always format("X= %X \n", X) }
}.

/* run */ define test_5() = {
  exists X,Y,Z: {
     X=0x4  and Y=1 and stable(Y) and
     X gets X + itompx(Y) and
     Z is mpxtoi(X) and
     format("Y=%d itompx(Y)= %X\n",Y,itompx(Y)) and
     len 10 and
     always format("X= %2X mpxtoi(X) = %2d\n", X, Z) }
}.

/* run */ define test_6() = {
 exists X : {
  list(X,5) and stable(struct X) and
  set zrandom_max = 0z5555 and
  set mp_random_seed = 0z55555 and
  forall i <|X| : { X[i] = mpztompx(zRandom) and X[i] gets X[i] + X[i] and len(5)} and
   always output X
 }
}.

/* run */ define test_7() = {
 exists X : {
  list(X,5) and stable(struct X) and
  set zrandom_max = 0z5555 and
  set mp_random_seed = 0z55555 and
  forall i <|X| : { X[i] = mpztompx(zRandom) and X[i] gets hex_com(X[i]) and len(5)} and
   always output X
 }
}.

/* run */ define test_8() = {
 exists X : {
  list(X,5) and stable(struct X) and
  set zrandom_max = 0z5555 and
  forall i <|X| : { X[i] = mpztompx(zRandom) and X[i] gets hex_and(X[i]+X[i],X[i]) and len(5)} and
   always output X
 }
}.
