# 
#
#
# Copyright (C) 2023 Antonio Cau

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

package require Plotchart

#package require NAME VERSION
package provide fuzzy_3d 1.0
# Namespace out --
#
#   ADD COMMENTS HERE
#
namespace eval ::out {;
    variable canv;



    
# init --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc init {nl} {
    variable canv;        
    variable s;
    variable data;

    set data {};

  $canv delete all
    
    set xlft   [lindex $nl 0];
    set xrght  [lindex $nl 1];
    set ylft   [lindex $nl 2];
    set yrght  [lindex $nl 3];
  
    set xcdom  [list $xlft $xrght [expr ($xrght - $xlft)/10]];
    set ycdom  [list $ylft $yrght [expr ($yrght - $ylft)/10]];
    
#
# Create the 3d plot with its x-, y-axes and z-axes
#
  set s [::Plotchart::create3DPlot $canv $xcdom $ycdom {0.0 1.01 0.1}];

   # set s [::Plotchart::create3DPlot $canv {0 10 3} {-10 10 10} {0 10 2.5}]
    $s title "3D Plot"
    $s colour "green" "black"
    $s gridsize 40 40

    
}

# add_to_data --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc add_to_data {nl} {
    variable data;

    lappend data $nl

}


# plot3d --
#
#   ADD COMMENTS HERE
#
# Arguments:
#   args	comments
# Results:
#   Returns ...
#
proc plot3d {nl} {

  variable canv;
  variable s;
  variable data;

  # z values 
  #set data { {1.0 2.0 3.0 5.0}
  #           {2.0 3.0 4.0 6.0}
  #           {4.0 5.0 6.0 7.0} }

  #set data1 { {1.0 2.0 1.0 0.0} {1.1 3.0 1.1 -0.5} {3.0 1.0 4.0 5.0} }

  set data2 {0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0} 

  #$s plotdata $data

  $s interpolatedata $data $data2
  
  

}

}; # end of namespace out

